//+------------------------------------------------------------------+
//|                                              MultiInstrument.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property strict

#property indicator_buffers 7
#property indicator_plots   7

#property indicator_type1   DRAW_LINE
#property indicator_type2   DRAW_LINE
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
#property indicator_type7   DRAW_LINE

#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_SOLID
#property indicator_style7 STYLE_SOLID

#property indicator_color1 clrAqua
#property indicator_color2 clrRed
#property indicator_color3 clrChartreuse
#property indicator_color4 clrOrange
#property indicator_color5 clrDarkViolet
#property indicator_color6 clrYellow
#property indicator_color7 clrHotPink

#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1

#define KEY_LEFT           37
#define KEY_RIGHT          39

input ENUM_TIMEFRAMES    timeframe=PERIOD_CURRENT;
string simbol_1 = "";// ""  
input string simbol_2 = "EURJPY";// ""  
extern bool revers_2 = false;
input string simbol_3 = "EURCHF";// ""  
extern bool revers_3 = false;
input string simbol_4 = "EURGBP";// ""  
extern bool revers_4 = false;
input string simbol_5 = "EURCAD";// ""  
extern bool revers_5 = false;
input string simbol_6 = "EURAUD";// ""  
extern bool revers_6 = false;
input string simbol_7 = "EURNZD";// ""  
extern bool revers_7 = false;
extern int ControlBars = 200;     //  
 int N           = 1;       //  N 
extern bool alerts           = false;     //   
extern bool otPosicii        = false;     //     
extern int SdvigSvechi         = 0;       //       
extern bool Pettern   = true; //   

int CorPeriod = 14; string comm = "";
input bool EnableComments = true;
bool revers[8];

double Buffer_1[];
double Buffer_2[];
double Buffer_3[];
double Buffer_4[];
double Buffer_5[];
double Buffer_6[];
double Buffer_7[];
string ValArr[7];
string Indexy[7]; string OsnoVal; string ext1, ext2;
int dvig = 0;
datetime svecha;
int Trace[7][11];    double handleMA[7];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   //ArraySetAsSeries(handleMA,true);
   if (simbol_1=="") simbol_1=Symbol();
   /*if (simbol_2=="") simbol_2=Symbol();
   if (simbol_3=="") simbol_3=Symbol();
   if (simbol_4=="") simbol_4=Symbol();
   if (simbol_5=="") simbol_5=Symbol();
   if (simbol_6=="") simbol_6=Symbol();
   if (simbol_7=="") simbol_7=Symbol();
   if (simbol_8=="") simbol_8=Symbol();*/
   ValArr[0] = simbol_1; ValArr[1] = simbol_2; ValArr[2] = simbol_3; ValArr[3] = simbol_4;
   ValArr[4] = simbol_5; ValArr[5] = simbol_6; ValArr[6] = simbol_7; 

   if(StringSubstr(ValArr[0],0,3)==StringSubstr(ValArr[1],0,3)){ OsnoVal=StringSubstr(ValArr[1],0,3); }
   if(StringSubstr(ValArr[0],3,3)==StringSubstr(ValArr[1],3,3)){ OsnoVal=StringSubstr(ValArr[1],3,3); }
   if(StringSubstr(ValArr[0],0,3)==StringSubstr(ValArr[1],3,3)){ OsnoVal=StringSubstr(ValArr[1],3,3); }
   if(StringSubstr(ValArr[0],3,3)==StringSubstr(ValArr[1],0,3)){ OsnoVal=StringSubstr(ValArr[1],0,3); }

   for(int vl=0;vl<=3;vl++){
      ext1 = StringSubstr(ValArr[vl],0,3);
      ext2 = StringSubstr(ValArr[vl],3,3);
      if(ext1 != OsnoVal){ Indexy[vl]=ext1; }
      if(ext2 != OsnoVal){ Indexy[vl]=ext2; }
   }
   

   /*******/
   for(int x=0;x<7;x++){ 
      handleMA[x]=iMA(ValArr[x],timeframe,N,0,MODE_SMA,PRICE_WEIGHTED);
      //---      
      if(handleMA[x]==INVALID_HANDLE) 
        { 
         //---        
         PrintFormat("     iRSI   %s/%s,   %d", ValArr[x], timeframe, GetLastError()); 
         //---     
         return(INIT_FAILED); 
        }    
   }


   if(SdvigSvechi>0){ dvig = SdvigSvechi; }else{ dvig = 0; }
   
   ArrayInitialize(revers,0);
   revers[1] = revers_2;
   revers[2] = revers_3;
   revers[3] = revers_4;
   revers[4] = revers_5;
   revers[5] = revers_6;
   revers[6] = revers_7;

   ObjectCreate(0,"Oblast",OBJ_RECTANGLE,0,TimeCurrent(),SymbolInfoDouble(simbol_1, SYMBOL_BID),TimeCurrent()-(60*timeframe*ControlBars),SymbolInfoDouble(simbol_1, SYMBOL_BID)+50*timeframe);
   ObjectSetInteger(0,"Oblast",OBJPROP_COLOR,clrYellow); 
   ObjectSetInteger(0,"Oblast",OBJPROP_WIDTH,0);
   ObjectSetInteger(0,"Oblast",OBJPROP_STYLE,STYLE_DASH);
   ObjectSetInteger(0,"Oblast",OBJPROP_FILL,false); 
   ObjectSetInteger(0,"Oblast",OBJPROP_BACK,false);
   
   ObjectCreate(0,"Center",OBJ_HLINE,0,0,0);
   ObjectSetInteger(0,"Center",OBJPROP_COLOR,clrYellow); 
   ObjectSetInteger(0,"Center",OBJPROP_WIDTH,0);
   ObjectSetInteger(0,"Center",OBJPROP_STYLE,STYLE_DASH);
   
   svecha = iTimeMQL4(Symbol(),0,dvig);
   int barshift = iBarShiftMQL4(Symbol(),0,svecha);
   ObjectCreate(0,"StartLine", OBJ_VLINE,0, svecha, 0);
   ObjectSetInteger(0,"StartLine",OBJPROP_COLOR,Red);
   ObjectSetInteger(0,"StartLine",OBJPROP_SELECTED,true);
   ObjectSetInteger(0,"StartLine",OBJPROP_SELECTABLE,true);
   ObjectSetInteger(0,"StartLine",OBJPROP_WIDTH,1);
   ObjectSetInteger(0,"StartLine",OBJPROP_STYLE,STYLE_DOT);
   
   double coordy = (iCloseMQL4(Symbol(),0,barshift)-800*Point());
   ObjectCreate(0,"podpis", OBJ_TEXT, 0, svecha, coordy);
   ObjectSetString(0,"podpis",OBJPROP_TEXT,"");
   ObjectSetInteger(0,"podpis",OBJPROP_FONTSIZE,16);
   ObjectSetInteger(0,"podpis",OBJPROP_COLOR, Yellow);
   ObjectSetInteger(0,"podpis",OBJPROP_WIDTH,2);

   if (simbol_1!="") {
      ObjectCreate(0,"pair1", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair1",OBJPROP_TEXT,simbol_1);
      ObjectSetInteger(0,"pair1",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair1",OBJPROP_COLOR, indicator_color1);
      ObjectSetInteger(0,"pair1",OBJPROP_WIDTH,2);
   }
   if (simbol_2!="") {
      ObjectCreate(0,"pair2", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair2",OBJPROP_TEXT,simbol_2);
      ObjectSetInteger(0,"pair2",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair2",OBJPROP_COLOR, indicator_color2);
      ObjectSetInteger(0,"pair2",OBJPROP_WIDTH,2);
   }
   if (simbol_3!="") {
      ObjectCreate(0,"pair3", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair3",OBJPROP_TEXT,simbol_3);
      ObjectSetInteger(0,"pair3",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair3",OBJPROP_COLOR, indicator_color3);
      ObjectSetInteger(0,"pair3",OBJPROP_WIDTH,2);
   }
   if (simbol_4!="") {
      ObjectCreate(0,"pair4", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair4",OBJPROP_TEXT,simbol_4);
      ObjectSetInteger(0,"pair4",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair4",OBJPROP_COLOR, indicator_color4);
      ObjectSetInteger(0,"pair4",OBJPROP_WIDTH,2);
   }
   if (simbol_5!="") {
      ObjectCreate(0,"pair5", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair5",OBJPROP_TEXT,simbol_5);
      ObjectSetInteger(0,"pair5",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair5",OBJPROP_COLOR, indicator_color5);
      ObjectSetInteger(0,"pair5",OBJPROP_WIDTH,2);
   }
   if (simbol_6!="") {
      ObjectCreate(0,"pair6", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair6",OBJPROP_TEXT,simbol_6);
      ObjectSetInteger(0,"pair6",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair6",OBJPROP_COLOR, indicator_color6);
      ObjectSetInteger(0,"pair6",OBJPROP_WIDTH,2);
   }
   if (simbol_7!="") {
      ObjectCreate(0,"pair7", OBJ_TEXT, 0, TimeCurrent()+Period()*60*5, 0);
      ObjectSetString(0,"pair7",OBJPROP_TEXT,simbol_7);
      ObjectSetInteger(0,"pair7",OBJPROP_FONTSIZE,6);
      ObjectSetInteger(0,"pair7",OBJPROP_COLOR, indicator_color7);
      ObjectSetInteger(0,"pair7",OBJPROP_WIDTH,2);
   }


   
   SetIndexBuffer(0,Buffer_1,INDICATOR_DATA);
   SetIndexBuffer(1,Buffer_2,INDICATOR_DATA);
   SetIndexBuffer(2,Buffer_3,INDICATOR_DATA);
   SetIndexBuffer(3,Buffer_4,INDICATOR_DATA);
   SetIndexBuffer(4,Buffer_5,INDICATOR_DATA);
   SetIndexBuffer(5,Buffer_6,INDICATOR_DATA);
   SetIndexBuffer(6,Buffer_7,INDICATOR_DATA);
   /*
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(1,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(2,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(3,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(4,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(5,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(6,PLOT_DRAW_TYPE,DRAW_LINE);
   
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,0,indicator_color1);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,1,indicator_color2);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,2,indicator_color3);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,3,indicator_color4);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,4,indicator_color5);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,5,indicator_color6);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,6,indicator_color7);
   */
   PlotIndexSetString(0,PLOT_LABEL,simbol_1);
   PlotIndexSetString(1,PLOT_LABEL,simbol_2);
   PlotIndexSetString(2,PLOT_LABEL,simbol_3);
   PlotIndexSetString(3,PLOT_LABEL,simbol_4);
   PlotIndexSetString(4,PLOT_LABEL,simbol_5);
   PlotIndexSetString(5,PLOT_LABEL,simbol_6);
   PlotIndexSetString(6,PLOT_LABEL,simbol_7);
   
   IndicatorSetInteger(INDICATOR_DIGITS,5);
   
   ArraySetAsSeries(Buffer_1,true);
   ArraySetAsSeries(Buffer_2,true);
   ArraySetAsSeries(Buffer_3,true);
   ArraySetAsSeries(Buffer_4,true);
   ArraySetAsSeries(Buffer_5,true);
   ArraySetAsSeries(Buffer_6,true);
   ArraySetAsSeries(Buffer_7,true);

   
   
//---
   return(INIT_SUCCEEDED);
  }


int deinit()
  {
   ObjectDelete(0,"StartLine");
   ObjectDelete(0,"podpis");
   ObjectDelete(0,"pair1");
   ObjectDelete(0,"pair2");
   ObjectDelete(0,"pair3");
   ObjectDelete(0,"pair4");
   ObjectDelete(0,"pair5");
   ObjectDelete(0,"pair6");
   ObjectDelete(0,"pair7");
   ObjectDelete(0,"pair8");
   ObjectDelete(0,"Oblast");
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(BarsCalculated(handleMA[0])<rates_total) return(0);
   
   int BarsWind; int sdvig=0;  comm = "";
   if (ControlBars!=0){ BarsWind=ControlBars; }else{ BarsWind=ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR,0); } 

   if(SdvigSvechi>0){
      sdvig = SdvigSvechi;
   }
   
   /*       0 - SdvigSvechi+BarsWind+1 */
   datetime timeshiftHL = iTimeMQL4(simbol_1,timeframe,sdvig);
   
   double High_Win,Low_Win;
   High_Win=iHighMQL4(simbol_1,timeframe, iHighestMQL4(simbol_1,timeframe, BarsWind, sdvig));
   Low_Win=iLowMQL4(simbol_1,timeframe, iLowestMQL4(simbol_1,timeframe, BarsWind, sdvig));
   
   double H_2, L_2;
   int shiftHL2 = iBarShiftMQL4(simbol_2,timeframe,timeshiftHL);
   H_2=iHighMQL4(simbol_2,timeframe,iHighestMQL4(simbol_2,timeframe,BarsWind,shiftHL2));
   L_2=iLowMQL4(simbol_2,timeframe,iLowestMQL4(simbol_2,timeframe, BarsWind,shiftHL2));
   
   double H_3, L_3;
   int shiftHL3 = iBarShiftMQL4(simbol_3,timeframe,timeshiftHL);
   H_3=iHighMQL4(simbol_3,timeframe,iHighestMQL4(simbol_3,timeframe,BarsWind,shiftHL3));
   L_3=iLowMQL4(simbol_3,timeframe,iLowestMQL4(simbol_3,timeframe, BarsWind,shiftHL3));
   
   double H_4, L_4;
   int shiftHL4 = iBarShiftMQL4(simbol_4,timeframe,timeshiftHL);
   H_4=iHighMQL4(simbol_4,timeframe,iHighestMQL4(simbol_4,timeframe,BarsWind,shiftHL4));
   L_4=iLowMQL4(simbol_4,timeframe,iLowestMQL4(simbol_4,timeframe, BarsWind,shiftHL4));
   
   double H_5, L_5;
   int shiftHL5 = iBarShiftMQL4(simbol_5,timeframe,timeshiftHL);
   H_5=iHighMQL4(simbol_5,timeframe,iHighestMQL4(simbol_5,timeframe,BarsWind,shiftHL5));
   L_5=iLowMQL4(simbol_5,timeframe,iLowestMQL4(simbol_5,timeframe, BarsWind,shiftHL5));
   
   double H_6, L_6;
   int shiftHL6 = iBarShiftMQL4(simbol_6,timeframe,timeshiftHL);
   H_6=iHighMQL4(simbol_6,timeframe,iHighestMQL4(simbol_6,timeframe,BarsWind,shiftHL6));
   L_6=iLowMQL4(simbol_6,timeframe,iLowestMQL4(simbol_6,timeframe, BarsWind,shiftHL6));
   
   double H_7, L_7;
   int shiftHL7 = iBarShiftMQL4(simbol_7,timeframe,timeshiftHL);
   H_7=iHighMQL4(simbol_7,timeframe,iHighestMQL4(simbol_7,timeframe,BarsWind,shiftHL7));
   L_7=iLowMQL4(simbol_7,timeframe,iLowestMQL4(simbol_7,timeframe, BarsWind,shiftHL7));
   
   
   //if(ArrayRange(Buffer_1,0)<(BarsWind+sdvig+2)){
      //Print("ArrayResize");
      //if(ArrayResize(Buffer_1,(BarsWind+sdvigbar2+3),0)<0){ Print("ArrayResize  "); }
      ArrayResize(Buffer_1,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_2,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_3,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_4,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_5,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_6,(BarsWind+sdvig+3),0);
      ArrayResize(Buffer_7,(BarsWind+sdvig+3),0);
   //}
   
   //   ima
   double ima[7][10000];
   
   for(int rr=0;rr<7;rr++){
      double tmpMA[];
      ArraySetAsSeries(tmpMA,true);
      if(!CopyBuffer(handleMA[rr],0,0,(BarsWind+sdvig+1),tmpMA)){ Print("iMA "+ValArr[rr]+"  ");  }
      //if(!FillArrayFromBuffer(tmpMA,0,handleMA[rr],(BarsWind+sdvig+1))){ Print("iMA "+ValArr[rr]+"  ");  }//return 0;
      for(int q=0;q<ArraySize(tmpMA);q++){
         ima[rr][q]=tmpMA[q];
      }
   }

   //for(int i=0;i<=BarsWind+sdvig; i++)
   for(int i=BarsWind+sdvig; i>=0; i--)
   {
      Buffer_1[i]= ima[0][i];
      datetime timeshift = iTimeMQL4(simbol_1,timeframe,i);
      
      if(simbol_2!=""){
         int shiftv2 = iBarShiftMQL4(simbol_2,timeframe,timeshift);
         if(!revers[1]){ // 
            Buffer_2[i]= (ima[1][i] - L_2)/(H_2 - L_2)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_2[i]= (H_2 - ima[1][i])/(H_2 - L_2)*(High_Win-Low_Win)+Low_Win;
         }
      } 
      if(simbol_3!=""){
         int shiftv3 = iBarShiftMQL4(simbol_3,timeframe,timeshift);
         if(!revers[2]){ // 
            Buffer_3[i]= (ima[2][i] - L_3)/(H_3 - L_3)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_3[i]= (H_3 - ima[2][i])/(H_3 - L_3)*(High_Win-Low_Win)+Low_Win;
         }
      }
      if(simbol_4!=""){
         int shiftv4 = iBarShiftMQL4(simbol_4,timeframe,timeshift);
         if(!revers[3]){ // 
            Buffer_4[i]= (ima[3][i] - L_4)/(H_4 - L_4)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_4[i]= (H_4 - ima[3][i])/(H_4 - L_4)*(High_Win-Low_Win)+Low_Win;
         }
      }
      if(simbol_5!=""){
         int shiftv5 = iBarShiftMQL4(simbol_5,timeframe,timeshift);
         if(!revers[4]){ // 
            Buffer_5[i]= (ima[4][i] - L_5)/(H_5 - L_5)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_5[i]= (H_5 - ima[4][i])/(H_5 - L_5)*(High_Win-Low_Win)+Low_Win;
         }
      }
      if(simbol_6!=""){
         int shiftv6 = iBarShiftMQL4(simbol_6,timeframe,timeshift);
         if(!revers[5]){ // 
            Buffer_6[i]= (ima[5][i] - L_6)/(H_6 - L_6)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_6[i]= (H_6 - ima[5][i])/(H_6 - L_6)*(High_Win-Low_Win)+Low_Win;
         }
      }
      if(simbol_7!=""){
         int shiftv7 = iBarShiftMQL4(simbol_7,timeframe,timeshift);
         //Print(i);
         if(!revers[6]){ // 
            Buffer_7[i]= (ima[6][i] - L_7)/(H_7 - L_7)*(High_Win-Low_Win)+Low_Win;
         }else{
            Buffer_7[i]= (H_7 - ima[6][i])/(H_7 - L_7)*(High_Win-Low_Win)+Low_Win;
         }
      }
   }
   
   //   - 
   double V[7]; V[0]= Buffer_1[sdvig]; V[1]= Buffer_2[sdvig]; V[2]= Buffer_3[sdvig]; V[3]= Buffer_4[sdvig];
   V[4]= Buffer_5[sdvig]; V[5]= Buffer_6[sdvig]; V[6]= Buffer_7[sdvig]; 
   //   - 
   double Vhod[7]; Vhod[0]= Buffer_1[sdvig+BarsWind]; Vhod[1]= Buffer_2[sdvig+BarsWind]; Vhod[2]= Buffer_3[sdvig+BarsWind]; Vhod[3]= Buffer_4[sdvig+BarsWind];
   Vhod[4]= Buffer_5[sdvig+BarsWind]; Vhod[5]= Buffer_6[sdvig+BarsWind]; Vhod[6]= Buffer_7[sdvig+BarsWind]; 
   
   int indxmax = ArrayMaximum(V,0,WHOLE_ARRAY);
   int indxmin = ArrayMinimum(V,0,WHOLE_ARRAY);
   int delta0 = MathCeil((V[indxmax]-V[indxmin])/_Point);
   
   datetime tut = iTimeMQL4(Symbol(),timeframe,sdvig);
   
   string SellTxt = "Sell";
   string BuyTxt = "Buy";
   if(revers[indxmax]){ SellTxt = "Buy Rev"; }
   if(revers[indxmin]){ BuyTxt = "Sell Rev"; }
   ObjectSetInteger(0,"StartLine",OBJPROP_TIME,tut);
   //ObjectSetString(0,"podpis",OBJPROP_TEXT,delta0+"; sell "+Valt[indxmax]+" buy "+Valt[indxmin]);
   comm = comm + "max "+ValArr[indxmax]+ " min "+ValArr[indxmin]+"\n";
   comm = comm + "  +"+sdvig+"   "+BarsWind+" \n";
   double DeltaHL = MathCeil((High_Win-Low_Win)/_Point);
   ObjectSetDouble(0,"podpis",OBJPROP_PRICE, (Low_Win-5*_Point));
   ObjectSetInteger(0,"podpis",OBJPROP_TIME,tut);
   ObjectSetString(0,"podpis",OBJPROP_TEXT,delta0+"; Canal= "+DeltaHL+"; "+SellTxt+" "+ValArr[indxmax]+" "+BuyTxt+" "+ValArr[indxmin]);
   //ObjectSetString(0,"podpis",OBJPROP_TEXT,delta0+"; 100= "+cor100+"; 1000= "+cor1000+"; "+SellTxt+" "+ValArr[indxmax]+" "+BuyTxt+" "+ValArr[indxmin]);
   
   ObjectMove(0,"Oblast",0,tut,Low_Win);
   ObjectMove(0,"Oblast",1,iTimeMQL4(Symbol(),0,(sdvig+BarsWind)),High_Win); 
   
   ObjectMove(0,"Center",0,tut,Low_Win+0.5*(High_Win-Low_Win));
   
   for(int ss=0;ss<7;ss++){
      if(ss==0 || (ss>0 && ValArr[ss]!=ValArr[0])){
         if(Vhod[ss]>=(High_Win-0.1*(High_Win-Low_Win))){ Trace[ss][0] = 1; }
         if(Vhod[ss]<(High_Win-0.1*(High_Win-Low_Win)) && Vhod[ss]>=(High_Win-0.3*(High_Win-Low_Win))){ Trace[ss][0] = 2; }
         if(Vhod[ss]<(High_Win-0.3*(High_Win-Low_Win)) && Vhod[ss]>=(High_Win-0.5*(High_Win-Low_Win))){ Trace[ss][0] = 3; }
         if(Vhod[ss]<(High_Win-0.5*(High_Win-Low_Win)) && Vhod[ss]>=(High_Win-0.7*(High_Win-Low_Win))){ Trace[ss][0] = 4; }
         if(Vhod[ss]<(High_Win-0.7*(High_Win-Low_Win)) && Vhod[ss]>=(High_Win-0.9*(High_Win-Low_Win))){ Trace[ss][0] = 5; }
         if(Vhod[ss]<=(Low_Win+0.1*(High_Win-Low_Win))){ Trace[ss][0] = 6; }
         ///
         if(V[ss]>=(High_Win-0.1*(High_Win-Low_Win))){ Trace[ss][10] = 1; }
         if(V[ss]<(High_Win-0.1*(High_Win-Low_Win)) && V[ss]>=(High_Win-0.3*(High_Win-Low_Win))){ Trace[ss][10] = 2; }
         if(V[ss]<(High_Win-0.3*(High_Win-Low_Win)) && V[ss]>=(High_Win-0.5*(High_Win-Low_Win))){ Trace[ss][10] = 3; }
         if(V[ss]<(High_Win-0.5*(High_Win-Low_Win)) && V[ss]>=(High_Win-0.7*(High_Win-Low_Win))){ Trace[ss][10] = 4; }
         if(V[ss]<(High_Win-0.7*(High_Win-Low_Win)) && V[ss]>=(High_Win-0.9*(High_Win-Low_Win))){ Trace[ss][10] = 5; }
         if(V[ss]<=(Low_Win+0.1*(High_Win-Low_Win))){ Trace[ss][10] = 6; }
         comm = comm + ValArr[ss]+"  = "+ Trace[ss][0]+"    = "+Trace[ss][10]+"    =="+Vhod[ss]+"\n";
      }
   }
   
   if(EnableComments){ Comment(comm); }
   if(sdvig>0){
      ObjectSetDouble(0,"pair1",OBJPROP_PRICE, (V[0]));
      ObjectSetInteger(0,"pair1",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair1",OBJPROP_TEXT,ValArr[0]);
      ObjectSetDouble(0,"pair2",OBJPROP_PRICE, (V[1]));
      ObjectSetInteger(0,"pair2",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair2",OBJPROP_TEXT,ValArr[1]);
      ObjectSetDouble(0,"pair3",OBJPROP_PRICE, (V[2]));
      ObjectSetInteger(0,"pair3",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair3",OBJPROP_TEXT,ValArr[2]);
      ObjectSetDouble(0,"pair4",OBJPROP_PRICE, (V[3]));
      ObjectSetInteger(0,"pair4",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair4",OBJPROP_TEXT,ValArr[3]);
      ObjectSetDouble(0,"pair5",OBJPROP_PRICE, (V[4]));
      ObjectSetInteger(0,"pair5",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair5",OBJPROP_TEXT,ValArr[4]);
      ObjectSetDouble(0,"pair6",OBJPROP_PRICE, (V[5]));
      ObjectSetInteger(0,"pair6",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair6",OBJPROP_TEXT,ValArr[5]);
      ObjectSetDouble(0,"pair7",OBJPROP_PRICE, (V[6]));
      ObjectSetInteger(0,"pair7",OBJPROP_TIME,tut);
      ObjectSetString(0,"pair7",OBJPROP_TEXT,ValArr[6]);
   }else{
      ObjectMove(0,"pair1", 0, TimeCurrent()+Period()*60*5, Buffer_1[0]);
      ObjectMove(0,"pair2", 0, TimeCurrent()+Period()*60*5, Buffer_2[0]);
      ObjectMove(0,"pair3", 0, TimeCurrent()+Period()*60*5, Buffer_3[0]);
      ObjectMove(0,"pair4", 0, TimeCurrent()+Period()*60*5, Buffer_4[0]);
      ObjectMove(0,"pair5", 0, TimeCurrent()+Period()*60*5, Buffer_5[0]);
      ObjectMove(0,"pair6", 0, TimeCurrent()+Period()*60*5, Buffer_6[0]);
      ObjectMove(0,"pair7", 0, TimeCurrent()+Period()*60*5, Buffer_7[0]);
   }

//--- return value of prev_calculated for next call
   return(rates_total); // 
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+


void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //    double
                  const string& sparam )  //    string
{
       //Print(id," | ",lparam," | ",dparam," | ",sparam," || ",SdvigSvechi);
       
    if(id==2 && sparam=="StartLine"){
       datetime SdvigTime = ObjectGetInteger(0,"StartLine",OBJPROP_TIME,0);
       SdvigSvechi = iBarShiftMQL4(Symbol(),0,SdvigTime);
       ObjectSetInteger(0,"StartLine",OBJPROP_TIME,SdvigTime);
       
       
       
    }
    if(id==0 && (lparam==39 || lparam==37)) 
     { 
      int oldSdvigSvechi = SdvigSvechi;
      switch(lparam) 
        { 
         case 37:          SdvigSvechi = SdvigSvechi+1;           break;
         case 39:         SdvigSvechi = SdvigSvechi-1;          break;
         default:                SdvigSvechi = SdvigSvechi;
        }
        if(SdvigSvechi!=oldSdvigSvechi){ ChartRedraw(0); }
     }
 
 return;
}


double iHighMQL4(string symbol,int tf,int index)
{
   if(index < 0) return(-1);
   double Arr[];
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(CopyHigh(symbol,timeframe, index, 1, Arr)>0) 
        return(Arr[0]);
   else return(-1);
}

int iHighestMQL4(string symbol,
                 int tf,
                 int count=WHOLE_ARRAY,
                 int start=0)
  {
   if(start<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(count<=0) count=Bars(symbol,timeframe);
   double High[];
   ArraySetAsSeries(High,true);
   CopyHigh(symbol,timeframe,start,count,High);
   return(ArrayMaximum(High,0,count)+start);
  }
  
double iLowMQL4(string symbol,int tf,int index)
{
   if(index < 0) return(-1);
   double Arr[];
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(CopyLow(symbol,timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}

int iLowestMQL4(string symbol,
                int tf,
                int count=WHOLE_ARRAY,
                int start=0)
  {
   if(start<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(count<=0) count=Bars(symbol,timeframe);
   double Low[];
   ArraySetAsSeries(Low,true);
   CopyLow(symbol,timeframe,start,count,Low);
   return(ArrayMinimum(Low,0,count)+start);
  }
  
int iBarShiftMQL4(string symbol,
                  int tf,
                  datetime time,
                  bool exact=false)
  {
   if(time<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   datetime Arr[],time1;
   CopyTime(symbol,timeframe,0,1,Arr);
   time1=Arr[0];
   if(CopyTime(symbol,timeframe,time,time1,Arr)>0)
     {
      if(ArraySize(Arr)>2) return(ArraySize(Arr)-1);
      if(time<time1) return(1);
      else return(0);
     }
   else return(-1);
  }
  
bool FillArrayFromBuffer(double &values[],   //    Moving Average 
                         int shift,          //  
                         int ind_handle,     //   iMA 
                         int amount          //    
                         ) 
  { 
//---    
   ResetLastError(); 
//---    iMABuffer       0 
   if(CopyBuffer(ind_handle,0,-shift,amount,values)<0) 
     { 
      //---    ,    
      PrintFormat("      iMA,   %d",GetLastError()); 
      //---     -  ,      
      return(false); 
     } 
//---   
   return(true); 
  }

ENUM_TIMEFRAMES TFMigrate(int tf)
  {
   switch(tf)
     {
      case 0: return(PERIOD_CURRENT);
      case 1: return(PERIOD_M1);
      case 5: return(PERIOD_M5);
      case 15: return(PERIOD_M15);
      case 30: return(PERIOD_M30);
      case 60: return(PERIOD_H1);
      case 240: return(PERIOD_H4);
      case 1440: return(PERIOD_D1);
      case 10080: return(PERIOD_W1);
      case 43200: return(PERIOD_MN1);
      
      case 2: return(PERIOD_M2);
      case 3: return(PERIOD_M3);
      case 4: return(PERIOD_M4);      
      case 6: return(PERIOD_M6);
      case 10: return(PERIOD_M10);
      case 12: return(PERIOD_M12);
      case 16385: return(PERIOD_H1);
      case 16386: return(PERIOD_H2);
      case 16387: return(PERIOD_H3);
      case 16388: return(PERIOD_H4);
      case 16390: return(PERIOD_H6);
      case 16392: return(PERIOD_H8);
      case 16396: return(PERIOD_H12);
      case 16408: return(PERIOD_D1);
      case 32769: return(PERIOD_W1);
      case 49153: return(PERIOD_MN1);      
      default: return(PERIOD_CURRENT);
     }
  }

double iOpenMQL4(string symbol,int tf,int index)
{   
   if(index < 0) return(-1);
   double Arr[];
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(CopyOpen(symbol,timeframe, index, 1, Arr)>0) 
        return(Arr[0]);
   else return(-1);
}

datetime iTimeMQL4(string symbol,int tf,int index)
{
   if(index < 0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   datetime Arr[];
   if(CopyTime(symbol, timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}

double iCloseMQL4(string symbol,int tf,int index)
{
   if(index < 0) return(-1);
   double Arr[];
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(CopyClose(symbol,timeframe, index, 1, Arr)>0) 
        return(Arr[0]);
   else return(-1);
}

